from abc import ABC, abstractmethod


class ViewGen(ABC):
    """
    Abstract class for View Generating Functions (VGFs) implementations. Every ViewGen should implement these three methods in order to
    be seamlessly integrated in the overall architecture.
    """

    @abstractmethod
    def fit(self, lX, lY):
        pass

    @abstractmethod
    def transform(self, lX):
        pass

    @abstractmethod
    def fit_transform(self, lX, lY):
        pass

    @abstractmethod
    def save_vgf(self, model_id):
        pass
